<template>
    <v-form v-model="valid" ref="form" lazy-validation>
        <v-card flat color="transparent">
            <v-toolbar color="primary" dark class="page-toolbar elevation-2" :extended="!!command">
                <v-toolbar-title class="white--text page-title">{{$t('Console')}}</v-toolbar-title>
                <v-autocomplete
                        :items="commands"
                        :placeholder="$t('Command')"
                        item-text="name"
                        single-line
                        dense
                        return-object
                        v-model="command"
                        flat
                        solo-inverted
                        class="ml-3 input-field"
                ></v-autocomplete>
                <div class="sub-title" slot="extension" v-if="command">{{commandDescription}}</div>
                <v-btn flat @click="cancel" icon v-if="inProgress"><v-icon>close</v-icon></v-btn>
                <v-btn flat round @click="run" :disabled="!runnable"><v-icon>play_arrow</v-icon> <span class="hidden-xs-only">{{$t('Run')}}</span></v-btn>
            </v-toolbar>

            <v-card-text class="p-relative">
                <v-container v-if="command" grid-list-sm fill-height>
                    <v-layout row wrap>
                        <v-flex v-if="command.arguments.length" d-flex>
                            <v-card>
                                <v-card-title :class="themeLight"><h4 class="subheading">{{$t('Arguments')}}</h4></v-card-title>
                                <v-divider></v-divider>
                                <v-card-text>
                                    <template v-for="arg in command.arguments">
                                        <v-text-field
                                                      :name="arg.name"
                                                      :label="arg.name"
                                                      :required="arg.required"
                                                      :hint="arg.description"
                                                      v-model="args[arg.name]"
                                                      :error-messages="errors['arguments.'+arg.name]"
                                        ></v-text-field>
                                    </template>
                                </v-card-text>
                            </v-card>
                        </v-flex>
                        <v-flex v-if="command.options.length" d-flex>
                            <v-card>
                                <v-card-title :class="themeLight"><h4 class="subheading">{{$t('Options')}}</h4></v-card-title>
                                <v-divider></v-divider>
                                <v-card-text>
                                    <template v-for="opt in command.options">
                                        <v-text-field v-if="opt.accept_value"
                                                      :name="opt.name"
                                                      :label="opt.name"
                                                      :required="opt.required"
                                                      :hint="opt.description"
                                                      v-model="options[opt.name]"
                                                      :error-messages="errors['options.'+opt.name]"
                                        ></v-text-field>
                                        <v-checkbox v-else
                                                    :name="opt.name"
                                                    :label="opt.name"
                                                    :hint="opt.description"
                                                    v-model="options[opt.name]"
                                        ></v-checkbox>
                                    </template>
                                </v-card-text>
                            </v-card>
                        </v-flex>
                    </v-layout>
                </v-container>

                <v-container grid-list-sm id="consoleOutput">
                    <v-layout v-if="output">
                        <v-flex sm12>
                            <v-card>
                                <v-card-title :class="themeLight"><h4 class="subheading">Output</h4></v-card-title>
                                <v-card-text :class="themeName" class="darken-4 grey--text text--lighten-3" style="overflow: auto">
                                    <pre>{{output}}</pre>
                                </v-card-text>
                            </v-card>
                        </v-flex>
                    </v-layout>
                </v-container>

                <div class="white-overlay z-p3 shad" v-if="inProgress">
                    <v-progress-circular indeterminate :size="50" color="primary"></v-progress-circular>
                </div>
            </v-card-text>
        </v-card>
    </v-form>
</template>

<script>

    import axios from './../plugins/axios';
    import { mapGetters } from 'vuex';

    const CancelToken = axios.CancelToken;
    let source = null;

    export default {
        data: () => ({
            commands: [],
            command: null,
            inProgress: false,
            args: {},
            options: {},
            output: null,
            valid: false
        }),

        computed: {
            commandDescription() {
              return this.command ? this.command.description : '';
            },

            runnable() {
                return this.command && !this.inProgress && this.valid;
            },

            ...mapGetters({
               'themeLight': 'theme/light',
               'themeName': 'theme/name',
               'errors': 'form/errors'
            })
        },

        watch: {
            command(cmd) {
                if (cmd) {
                    if (cmd.arguments) {
                        for (let arg of cmd.arguments) {
                            if (typeof arg.default !== 'undefined' && arg.default) {
                                this.args[arg.name] = arg.default;
                            }
                        }
                    }
                    if (cmd.options) {
                        for (let opt of cmd.options) {
                            if (typeof opt.default !== 'undefined' && opt.default) {
                                this.options[opt.name] = opt.default;
                            }
                        }
                    }
                }
            }
        },

        created() {
            axios.get('console/commands.json').then((response) => {
                this.commands = response.data;
            });
        },

        methods: {
            run() {
                if (!this.command || !this.$refs.form.validate()) {
                    return false;
                }

                this.cancel();
                this.inProgress = true;
                source = CancelToken.source();

                this.output = null;
                let args = Object.assign({}, this.args);
                let opts = Object.assign({}, this.options);

                this.$store.commit('form/clearErrors');

                axios.post('console', {
                    command: this.command.name,
                    arguments: args,
                    options: opts
                }, {
                    cancelToken: source.token,
                }).then((response) => {
                    this.output = response.data;
                    this.inProgress = false;
                    this.$vuetify.goTo('#consoleOutput');
                })
                    .catch(e => {
                        this.inProgress = false;
                        if (axios.isCancel(e)) {
                            return;
                        }
                    });
            },

            cancel() {
                if (source) {
                    source.cancel();
                }
            }
        }
    }
</script>
